import { Title, Description, Primary } from '@storybook/addon-docs/blocks';
import React from 'react';
import AdvertisingConfigPropType from '../components/utils/AdvertisingConfigPropType';
import { AdvertisingProvider, AdvertisingSlot } from '../index';
import { GptDecorator } from './utils';
export var DefaultStory = function DefaultStory() {
  var config = {
    slots: [{
      id: 'banner-ad',
      path: '/6355419/Travel/Europe/France/Paris',
      sizes: [[300, 250]]
    }]
  };
  return /*#__PURE__*/React.createElement(AdvertisingProvider, {
    config: config
  }, /*#__PURE__*/React.createElement(AdvertisingSlot, {
    id: "banner-ad"
  }));
};
DefaultStory.propTypes = {
  config: AdvertisingConfigPropType
};
DefaultStory.storyName = 'GPT Banner';
export default {
  title: 'GPT Banner',
  decorators: [GptDecorator],
  parameters: {
    docs: {
      // see https://github.com/storybookjs/storybook/issues/12022
      source: {
        type: 'code'
      },
      description: {
        component: "\nIn this most basic example of them all, we show a medium rectangle banner\n(320x200 pixels) delivered by the Google Ad Manager, through Google Publisher \nTag (GPT).\n        "
      },
      page: function page() {
        return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Title, null), /*#__PURE__*/React.createElement(Description, null), /*#__PURE__*/React.createElement(Primary, null));
      }
    }
  }
};