import { Title, Description, Primary } from '@storybook/addon-docs/blocks';
import React from 'react';
import AdvertisingConfigPropType from '../components/utils/AdvertisingConfigPropType';
import { AdvertisingProvider, AdvertisingSlot } from '../index';
import { GptDecorator } from './utils';
export var DefaultStory = function DefaultStory() {
  var config = {
    interstitialSlot: {
      path: '/4288/mobile.homepage/Mob_Interstitial',
      targeting: {
        a: 'm138',
        eagt: '1555325533'
      }
    }
  };
  return /*#__PURE__*/React.createElement(AdvertisingProvider, {
    config: config
  }, /*#__PURE__*/React.createElement(AdvertisingSlot, {
    id: "banner-ad"
  }));
};
DefaultStory.propTypes = {
  config: AdvertisingConfigPropType
};
DefaultStory.storyName = 'GPT Interstitial';
export default {
  title: 'GPT Interstitial',
  decorators: [GptDecorator],
  parameters: {
    docs: {
      // see https://github.com/storybookjs/storybook/issues/12022
      source: {
        type: 'code'
      },
      description: {
        component: "\nIn example of them all, we show an interstitial ad, delivered by the Google Ad \nManager, through Google Publisher Tag (GPT).\n        "
      },
      page: function page() {
        return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Title, null), /*#__PURE__*/React.createElement(Description, null), /*#__PURE__*/React.createElement(Primary, null));
      }
    }
  }
};