import { Title, Description, Primary } from '@storybook/addon-docs/blocks';
import React from 'react';
import AdvertisingConfigPropType from '../components/utils/AdvertisingConfigPropType';
import { AdvertisingProvider, AdvertisingSlot } from '../index';
import { GptDecorator, Spacer, RowLayout } from './utils';
export var DefaultStory = function DefaultStory() {
  var config = {
    slots: [{
      id: 'gpt-ad01',
      path: '/6355419/Travel/Europe/France',
      sizes: [[728, 90]]
    }, {
      id: 'gpt-ad02',
      path: '/6355419/Travel/Europe/Spain',
      sizes: [[728, 90]]
    }, {
      id: 'gpt-ad03',
      path: '/6355419/Travel/Europe/Italy',
      sizes: [[728, 90]]
    }, {
      id: 'gpt-ad04',
      path: '/6355419/Travel/Europe/Portugal',
      sizes: [[728, 90]]
    }],
    enableLazyLoad: true,
    targeting: {
      test: 'lazyload'
    }
  };
  return /*#__PURE__*/React.createElement(AdvertisingProvider, {
    config: config
  }, /*#__PURE__*/React.createElement("p", null, "\uD83D\uDC47\uD83C\uDFFB Scroll down to see lazy loaded ads"), /*#__PURE__*/React.createElement(RowLayout, null, /*#__PURE__*/React.createElement(AdvertisingSlot, {
    id: "gpt-ad01"
  }), /*#__PURE__*/React.createElement(Spacer, {
    height: 150
  }), /*#__PURE__*/React.createElement(AdvertisingSlot, {
    id: "gpt-ad02"
  }), /*#__PURE__*/React.createElement(Spacer, {
    height: 150
  }), /*#__PURE__*/React.createElement(AdvertisingSlot, {
    id: "gpt-ad03"
  }), /*#__PURE__*/React.createElement(Spacer, {
    height: 150
  }), /*#__PURE__*/React.createElement(AdvertisingSlot, {
    id: "gpt-ad04"
  })));
};
DefaultStory.propTypes = {
  config: AdvertisingConfigPropType
};
DefaultStory.storyName = 'GPT Lazy Loading';
export default {
  title: 'GPT Lazy Loading',
  decorators: [GptDecorator],
  parameters: {
    docs: {
      // see https://github.com/storybookjs/storybook/issues/12022
      source: {
        type: 'code'
      },
      description: {
        component: "\nThis example show how you can \u201Clazy load\u201D ads, i.e. the ad slots on a long page get only activated and filled with \nbanners when they the user scrolls down the page and the ads are almost in the browser viewport. \n        "
      },
      page: function page() {
        return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Title, null), /*#__PURE__*/React.createElement(Description, null), /*#__PURE__*/React.createElement(Primary, null));
      }
    }
  }
};