export var DIV_ID_FOO = 'div-gpt-ad-foo';
var SLOT_ID_FOO = 666;
var PREBID_SIZES_FOO = [[320, 240]];
var BIDDER_FOO = 'bidder-foo';
var PARAMS_FOO = {
  foo: 'bar'
};
export var DIV_ID_BAR = 'div-gpt-ad-bar';
var SLOT_ID_BAR = [11, 666];
var PREBID_SIZES_BAR = [[320, 240]];
var BIDDER_BAR = 'bidder-bar';
var PARAMS_BAR = {
  bar: 'foo'
};
var COLLAPSE_EMPTY_DIV = [true, true];
var GPT_SIZES = ['fluid', [320, 240]];
var GLOBAL_AD_UNIT_PATH = 'global/ad/unit/path';
var SLOT_AD_UNIT_PATH = 'slot/ad/unit/path';
var USD_TO_EUR_RATE = 2;
export var config = {
  active: true,
  path: GLOBAL_AD_UNIT_PATH,
  prebid: {
    bidderTimeout: 1500,
    priceGranularity: 'medium',
    bidderSequence: 'random'
  },
  slots: [{
    id: DIV_ID_FOO,
    targeting: {
      a: SLOT_ID_FOO
    },
    sizes: GPT_SIZES,
    prebid: [{
      mediaTypes: {
        banner: {
          sizes: PREBID_SIZES_FOO
        }
      },
      bids: [{
        bidder: BIDDER_FOO,
        params: PARAMS_FOO
      }]
    }]
  }, {
    id: DIV_ID_BAR,
    path: SLOT_AD_UNIT_PATH,
    targeting: {
      a: SLOT_ID_BAR
    },
    sizes: GPT_SIZES,
    sizeMappingName: 'mobailAndTablet',
    collapseEmptyDiv: COLLAPSE_EMPTY_DIV,
    prebid: [{
      mediaTypes: {
        banner: {
          sizes: PREBID_SIZES_BAR
        }
      },
      bids: [{
        bidder: BIDDER_BAR,
        params: PARAMS_BAR
      }]
    }]
  }],
  sizeMappings: {
    mobailAndTablet: [{
      viewPortSize: [0, 0],
      sizes: []
    }, {
      viewPortSize: [320, 700],
      sizes: [[300, 250], [320, 50]]
    }, {
      viewPortSize: [1050, 200],
      sizes: []
    }]
  },
  metaData: {
    usdToEurRate: USD_TO_EUR_RATE
  },
  targeting: {
    eagt: [666],
    'mt-ab': 'test',
    'mt-ma': ['Poserwagen'],
    'mt-mo': ['Brummstinko', 'Grand Umweltverpestino'],
    'mt-thread': [666],
    'mt-u2': ['00'],
    'mt-u4': true
  },
  customEvents: {
    collapse: {
      eventMessagePrefix: 'CloseAdvContainer:',
      divIdPrefix: 'div-gpt-ad-'
    }
  }
};