"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _AdvertisingContext = _interopRequireDefault(require("../AdvertisingContext"));

var _calculateRootMargin = _interopRequireDefault(require("./utils/calculateRootMargin"));

var _isLazyLoading = _interopRequireDefault(require("./utils/isLazyLoading"));

var _getLazyLoadConfig = _interopRequireDefault(require("./utils/getLazyLoadConfig"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function AdvertisingSlot(_ref) {
  var id = _ref.id,
      style = _ref.style,
      className = _ref.className,
      children = _ref.children,
      customEventHandlers = _ref.customEventHandlers;
  var observerRef = (0, _react.useRef)(null);
  var containerDivRef = (0, _react.useRef)();

  var _useContext = (0, _react.useContext)(_AdvertisingContext["default"]),
      activate = _useContext.activate,
      config = _useContext.config;

  var lazyLoadConfig = (0, _getLazyLoadConfig["default"])(config, id);
  var isLazyLoadEnabled = (0, _isLazyLoading["default"])(lazyLoadConfig);
  (0, _react.useEffect)(function () {
    if (!config || !isLazyLoadEnabled) {
      return function () {};
    }

    var rootMargin = (0, _calculateRootMargin["default"])(lazyLoadConfig);
    observerRef.current = new IntersectionObserver(function (_ref2) {
      var _ref3 = (0, _slicedToArray2["default"])(_ref2, 1),
          isIntersecting = _ref3[0].isIntersecting;

      if (isIntersecting) {
        activate(id, customEventHandlers);
        observerRef.current.unobserve(containerDivRef.current);
      }
    }, {
      rootMargin: rootMargin
    });
    observerRef.current.observe(containerDivRef.current);
    return function () {
      observerRef.current.unobserve(containerDivRef.current);
    };
  }, [activate, config]);
  (0, _react.useEffect)(function () {
    if (!config || isLazyLoadEnabled) {
      return;
    }

    activate(id, customEventHandlers);
  }, [activate, config]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    id: id,
    style: style,
    className: className,
    children: children,
    ref: containerDivRef
  });
}

AdvertisingSlot.propTypes = {
  id: _propTypes["default"].string.isRequired,
  style: _propTypes["default"].object,
  className: _propTypes["default"].string,
  children: _propTypes["default"].node,
  customEventHandlers: _propTypes["default"].objectOf(_propTypes["default"].func).isRequired
};
AdvertisingSlot.defaultProps = {
  customEventHandlers: {}
};
var _default = AdvertisingSlot;
exports["default"] = _default;