"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _AdvertisingSlotConfigPropType = _interopRequireDefault(require("./AdvertisingSlotConfigPropType"));

var _default = _propTypes["default"].shape({
  path: _propTypes["default"].string,
  targeting: _propTypes["default"].object,
  usePrebid: _propTypes["default"].bool,
  prebid: _propTypes["default"].shape({
    debug: _propTypes["default"].bool,
    bidderTimeout: _propTypes["default"].number,
    enableSendAllBids: _propTypes["default"].bool,
    bidderSequence: _propTypes["default"].oneOf(['random', 'fixed']),
    publisherDomain: _propTypes["default"].string,
    cookieSyncDelay: _propTypes["default"].number,
    priceGranularity: _propTypes["default"].oneOfType([_propTypes["default"].oneOf(['low', 'medium', 'high', 'auto', 'dense']), _propTypes["default"].shape({
      buckets: _propTypes["default"].arrayOf(_propTypes["default"].shape({
        precision: _propTypes["default"].number,
        min: _propTypes["default"].number.isRequired,
        max: _propTypes["default"].number.isRequired,
        increment: _propTypes["default"].number.isRequired
      })).isRequired
    })]),
    mediaTypePriceGranularity: _propTypes["default"].shape({
      video: _propTypes["default"].oneOfType([_propTypes["default"].oneOf(['low', 'medium', 'high', 'auto', 'dense']), _propTypes["default"].shape({
        buckets: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          precision: _propTypes["default"].number,
          min: _propTypes["default"].number.isRequired,
          max: _propTypes["default"].number.isRequired,
          increment: _propTypes["default"].number.isRequired
        })).isRequired
      })]),
      banner: _propTypes["default"].oneOfType([_propTypes["default"].oneOf(['low', 'medium', 'high', 'auto', 'dense']), _propTypes["default"].shape({
        buckets: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          precision: _propTypes["default"].number,
          min: _propTypes["default"].number.isRequired,
          max: _propTypes["default"].number.isRequired,
          increment: _propTypes["default"].number.isRequired
        })).isRequired
      })]),
      "native": _propTypes["default"].oneOfType([_propTypes["default"].oneOf(['low', 'medium', 'high', 'auto', 'dense']), _propTypes["default"].shape({
        buckets: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          precision: _propTypes["default"].number,
          min: _propTypes["default"].number.isRequired,
          max: _propTypes["default"].number.isRequired,
          increment: _propTypes["default"].number.isRequired
        })).isRequired
      })])
    }),
    sizeConfig: _propTypes["default"].arrayOf(_propTypes["default"].shape({
      mediaQuery: _propTypes["default"].string.isRequired,
      sizesSupported: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].number)])),
      labels: _propTypes["default"].arrayOf(_propTypes["default"].string)
    }))
  }),
  sizeMappings: _propTypes["default"].objectOf(_propTypes["default"].arrayOf(_propTypes["default"].shape({
    viewPortSize: _propTypes["default"].arrayOf(_propTypes["default"].number).isRequired,
    sizes: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].number)])).isRequired
  }))),
  slots: _propTypes["default"].arrayOf(_AdvertisingSlotConfigPropType["default"]),
  outOfPageSlots: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    id: _propTypes["default"].string
  })),
  interstitialSlot: _propTypes["default"].shape({
    path: _propTypes["default"].string.isRequired,
    targeting: _propTypes["default"].object
  }),
  customEvents: _propTypes["default"].objectOf(_propTypes["default"].shape({
    eventMessagePrefix: _propTypes["default"].string.isRequired,
    divIdPrefix: _propTypes["default"].string
  })),
  enableLazyLoad: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].shape({
    marginPercent: _propTypes["default"].number,
    mobileScaling: _propTypes["default"].number
  })])
});

exports["default"] = _default;