"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.DefaultStory = void 0;

var _blocks = require("@storybook/addon-docs/blocks");

var _react = _interopRequireDefault(require("react"));

var _AdvertisingConfigPropType = _interopRequireDefault(require("../components/utils/AdvertisingConfigPropType"));

var _index = require("../index");

var _utils = require("./utils");

var DefaultStory = function DefaultStory() {
  var config = {
    slots: [{
      id: 'gpt-ad01',
      path: '/6355419/Travel/Europe/France',
      sizes: [[728, 90]]
    }, {
      id: 'gpt-ad02',
      path: '/6355419/Travel/Europe/Spain',
      sizes: [[728, 90]]
    }, {
      id: 'gpt-ad03',
      path: '/6355419/Travel/Europe/Italy',
      sizes: [[728, 90]]
    }, {
      id: 'gpt-ad04',
      path: '/6355419/Travel/Europe/Portugal',
      sizes: [[728, 90]]
    }],
    enableLazyLoad: true,
    targeting: {
      test: 'lazyload'
    }
  };
  return /*#__PURE__*/_react["default"].createElement(_index.AdvertisingProvider, {
    config: config
  }, /*#__PURE__*/_react["default"].createElement("p", null, "\uD83D\uDC47\uD83C\uDFFB Scroll down to see lazy loaded ads"), /*#__PURE__*/_react["default"].createElement(_utils.RowLayout, null, /*#__PURE__*/_react["default"].createElement(_index.AdvertisingSlot, {
    id: "gpt-ad01"
  }), /*#__PURE__*/_react["default"].createElement(_utils.Spacer, {
    height: 150
  }), /*#__PURE__*/_react["default"].createElement(_index.AdvertisingSlot, {
    id: "gpt-ad02"
  }), /*#__PURE__*/_react["default"].createElement(_utils.Spacer, {
    height: 150
  }), /*#__PURE__*/_react["default"].createElement(_index.AdvertisingSlot, {
    id: "gpt-ad03"
  }), /*#__PURE__*/_react["default"].createElement(_utils.Spacer, {
    height: 150
  }), /*#__PURE__*/_react["default"].createElement(_index.AdvertisingSlot, {
    id: "gpt-ad04"
  })));
};

exports.DefaultStory = DefaultStory;
DefaultStory.propTypes = {
  config: _AdvertisingConfigPropType["default"]
};
DefaultStory.storyName = 'GPT Lazy Loading';
var _default = {
  title: 'GPT Lazy Loading',
  decorators: [_utils.GptDecorator],
  parameters: {
    docs: {
      // see https://github.com/storybookjs/storybook/issues/12022
      source: {
        type: 'code'
      },
      description: {
        component: "\nThis example show how you can \u201Clazy load\u201D ads, i.e. the ad slots on a long page get only activated and filled with \nbanners when they the user scrolls down the page and the ads are almost in the browser viewport. \n        "
      },
      page: function page() {
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_blocks.Title, null), /*#__PURE__*/_react["default"].createElement(_blocks.Description, null), /*#__PURE__*/_react["default"].createElement(_blocks.Primary, null));
      }
    }
  }
};
exports["default"] = _default;